﻿using I2.Loc;
using Mono.Unix.Native;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using TMPro;
using UnityEngine;
using UnityEngine.UI;
using static Mono.Math.BigInteger;
using static SO_TradingPost_Buyable;

public class DirectionalSign_Network : MonoBehaviour_Network
{
    protected bool isPlaced = false;
    protected Raft_Network network;
    public DirectionalSignAdditionalData sign_data;
    public GameObject sign_1;
    public GameObject sign_2;
    public GameObject sign_3;
    public GameObject sign_4;
    public GameObject sign_5;
    public GameObject top;
    public uint index;

    public virtual void OnBlockPlaced()
    {
        NetworkIDManager.AddNetworkID(this);
        this.network = ComponentManager<Raft_Network>.Value;
        this.index = base.ObjectIndex;
        this.isPlaced = true;

        DirectionalSigns.signs.Add(this.index, this);

        top = this.GetComponentsInChildren<MeshRenderer>().First(x => x.gameObject.name.Contains("DirectionalSignTop")).gameObject;

        DirectionalSignBaseRay controls;
        var ray_component = this.GetComponentsInChildren<RaycastInteractable>().First(x => x.gameObject.name.Contains("Controls"));
        controls = ray_component.gameObject.AddComponent<DirectionalSignBaseRay>();
        controls.network = this;

        var raycast = ray_component.GetComponent<RaycastInteractable>();
        raycast.AddRaycastables(new IRaycastable[] { controls });

        sign_1 = Instantiate(DirectionalSigns.tobject);
        sign_1.transform.parent = this.transform;
        sign_1.transform.localRotation = new Quaternion(0.0f, 0.0f, 0.0f, 0.0f);
        sign_1.transform.localPosition = new Vector3(0.0f, 1.452006f, 0.0f);
        sign_1.transform.localScale = new Vector3(1.0f, 1.0f, 1.0f);
        this.top.transform.localPosition = new Vector3(0.0f, 1.58731f, 0.0f);

        sign_2 = Instantiate(DirectionalSigns.tobject);
        sign_2.transform.parent = this.transform;
        sign_2.transform.localRotation = new Quaternion(0.0f, 0.0f, 0.0f, 0.0f);
        sign_2.transform.localPosition = new Vector3(0.0f, 1.651906f, 0.0f);
        sign_2.transform.localScale = new Vector3(1.0f, 1.0f, 1.0f);
        sign_2.SetActive(false);

        sign_3 = Instantiate(DirectionalSigns.tobject);
        sign_3.transform.parent = this.transform;
        sign_3.transform.localRotation = new Quaternion(0.0f, 0.0f, 0.0f, 0.0f);
        sign_3.transform.localPosition = new Vector3(0.0f, 1.851806f, 0.0f);
        sign_3.transform.localScale = new Vector3(1.0f, 1.0f, 1.0f);
        sign_3.SetActive(false);

        sign_4 = Instantiate(DirectionalSigns.tobject);
        sign_4.transform.parent = this.transform;
        sign_4.transform.localRotation = new Quaternion(0.0f, 0.0f, 0.0f, 0.0f);
        sign_4.transform.localPosition = new Vector3(0.0f, 2.051706f, 0.0f);
        sign_4.transform.localScale = new Vector3(1.0f, 1.0f, 1.0f);
        sign_4.SetActive(false);

        sign_5 = Instantiate(DirectionalSigns.tobject);
        sign_5.transform.parent = this.transform;
        sign_5.transform.localRotation = new Quaternion(0.0f, 0.0f, 0.0f, 0.0f);
        sign_5.transform.localPosition = new Vector3(0.0f, 2.251606f, 0.0f);
        sign_5.transform.localScale = new Vector3(1.0f, 1.0f, 1.0f);
        sign_5.SetActive(false);

        sign_data = new DirectionalSignAdditionalData(true, "", 0.0f, false, "", 0.0f, false, "", 0.0f, false, "", 0.0f, false, "", 0.0f);
    }

    public void RestoreData(RGD_Storage rgd)
    {
        DirectionalSignAdditionalData sign_data = JsonUtility.FromJson<DirectionalSignAdditionalData>(rgd.slots[0].exclusiveString);

        sign_1.SetActive(sign_data.sign_1_enabled);
        foreach (TMP_Text text in sign_1.gameObject.GetComponentsInChildren<TMP_Text>())
        {
            text.text = sign_data.sign_1_text;
        }
        sign_1.transform.localRotation = Quaternion.Euler(transform.localEulerAngles.x, sign_data.sign_1_rotation, transform.localEulerAngles.z);

        sign_2.SetActive(sign_data.sign_2_enabled);
        foreach (TMP_Text text in sign_2.gameObject.GetComponentsInChildren<TMP_Text>())
        {
            text.text = sign_data.sign_2_text;
        }
        sign_2.transform.localRotation = Quaternion.Euler(transform.localEulerAngles.x, sign_data.sign_2_rotation, transform.localEulerAngles.z);

        sign_3.SetActive(sign_data.sign_3_enabled);
        foreach (TMP_Text text in sign_3.gameObject.GetComponentsInChildren<TMP_Text>())
        {
            text.text = sign_data.sign_3_text;
        }
        sign_3.transform.localRotation = Quaternion.Euler(transform.localEulerAngles.x, sign_data.sign_3_rotation, transform.localEulerAngles.z);

        sign_4.SetActive(sign_data.sign_4_enabled);
        foreach (TMP_Text text in sign_4.gameObject.GetComponentsInChildren<TMP_Text>())
        {
            text.text = sign_data.sign_4_text;
        }
        sign_4.transform.localRotation = Quaternion.Euler(transform.localEulerAngles.x, sign_data.sign_4_rotation, transform.localEulerAngles.z);

        sign_5.SetActive(sign_data.sign_5_enabled);
        foreach (TMP_Text text in sign_5.gameObject.GetComponentsInChildren<TMP_Text>())
        {
            text.text = sign_data.sign_5_text;
        }
        sign_5.transform.localRotation = Quaternion.Euler(transform.localEulerAngles.x, sign_data.sign_5_rotation, transform.localEulerAngles.z);

        if(sign_data.sign_1_enabled && !sign_data.sign_2_enabled && !sign_data.sign_3_enabled && !sign_data.sign_4_enabled && !sign_data.sign_5_enabled)
        {
            top.transform.localPosition = new Vector3(0.0f, 1.58731f, 0.0f);
        }
        else if (sign_data.sign_1_enabled && sign_data.sign_2_enabled && !sign_data.sign_3_enabled && !sign_data.sign_4_enabled && !sign_data.sign_5_enabled)
        {
            top.transform.localPosition = new Vector3(0.0f, 1.78721f, 0.0f);
        }
        else if (sign_data.sign_1_enabled && sign_data.sign_2_enabled && sign_data.sign_3_enabled && !sign_data.sign_4_enabled && !sign_data.sign_5_enabled)
        {
            top.transform.localPosition = new Vector3(0.0f, 1.98711f, 0.0f);
        }
        else if (sign_data.sign_1_enabled && sign_data.sign_2_enabled && sign_data.sign_3_enabled && sign_data.sign_4_enabled && !sign_data.sign_5_enabled)
        {
            top.transform.localPosition = new Vector3(0.0f, 2.18701f, 0.0f);
        }
        else if (sign_data.sign_1_enabled && sign_data.sign_2_enabled && sign_data.sign_3_enabled && sign_data.sign_4_enabled && sign_data.sign_5_enabled)
        {
            top.transform.localPosition = new Vector3(0.0f, 2.38691f, 0.0f);
        }

        this.sign_data = sign_data;
    }

    public override RGD Serialize_Save()
    {
        RGD_Storage rgd = CreateObject<RGD_Storage>();
        rgd.CopyFieldsOf(new RGD_Block(RGDType.Block, this.GetComponent<Block>()));
        rgd.slots = new RGD_Slot[] { CreateObject<RGD_Slot>() };
        rgd.slots[0].exclusiveString = JsonUtility.ToJson(this.sign_data);
        return rgd;
    }

    public static T CreateObject<T>() => (T)FormatterServices.GetUninitializedObject(typeof(T));
}

[Serializable]
public class DirectionalSignAdditionalData
{
    public bool sign_1_enabled;
    public string sign_1_text;
    public float sign_1_rotation;

    public bool sign_2_enabled;
    public string sign_2_text;
    public float sign_2_rotation;

    public bool sign_3_enabled;
    public string sign_3_text;
    public float sign_3_rotation;

    public bool sign_4_enabled;
    public string sign_4_text;
    public float sign_4_rotation;

    public bool sign_5_enabled;
    public string sign_5_text;
    public float sign_5_rotation;

    public DirectionalSignAdditionalData(bool sign_1_enabled, string sign_1_text, float sign_1_rotation, bool sign_2_enabled, string sign_2_text, float sign_2_rotation, bool sign_3_enabled, string sign_3_text, float sign_3_rotation, bool sign_4_enabled, string sign_4_text, float sign_4_rotation, bool sign_5_enabled, string sign_5_text, float sign_5_rotation)
    {
        this.sign_1_enabled = sign_1_enabled;
        this.sign_1_text = sign_1_text;
        this.sign_1_rotation = sign_1_rotation;

        this.sign_2_enabled = sign_2_enabled;
        this.sign_2_text = sign_2_text;
        this.sign_2_rotation = sign_2_rotation;

        this.sign_3_enabled = sign_3_enabled;
        this.sign_3_text = sign_3_text;
        this.sign_3_rotation = sign_3_rotation;

        this.sign_4_enabled = sign_4_enabled;
        this.sign_4_text = sign_4_text;
        this.sign_4_rotation = sign_4_rotation;

        this.sign_5_enabled = sign_5_enabled;
        this.sign_5_text = sign_5_text;
        this.sign_5_rotation = sign_5_rotation;
    }
}

[Serializable]
public class DirectionalSign_ChangeData : Message
{
    public uint object_index;
    public DirectionalSignAdditionalData data;

    public DirectionalSign_ChangeData(Messages type, uint object_index, DirectionalSignAdditionalData data) : base(type)
    {
        this.object_index = object_index;
        this.data = data;
    }
}


public static class ExtensionMethods
{
    // Thanks aidan for this one.
    public static void CopyFieldsOf(this object value, object source)
    {
        var t1 = value.GetType();
        var t2 = source.GetType();
        while (!t1.IsAssignableFrom(t2))
            t1 = t1.BaseType;
        while (t1 != typeof(UnityEngine.Object) && t1 != typeof(object))
        {
            foreach (var f in t1.GetFields(~BindingFlags.Default))
                if (!f.IsStatic)
                    f.SetValue(value, f.GetValue(source));
            t1 = t1.BaseType;
        }
    }
}


class DirectionalSignBaseRay : MonoBehaviour, IRaycastable
{
    protected bool showingText = false;
    public DirectionalSign_Network network;

    void IRaycastable.OnIsRayed()
    {
        CanvasHelper canvas = ComponentManager<CanvasHelper>.Value;
        canvas.displayTextManager.ShowText(LocalizationManager.GetTranslation("DirectionalSign/Change", true, 0, true, false, null, null), MyInput.Keybinds["Interact"].MainKey);
        this.showingText = true;
        if (MyInput.GetButtonDown("Interact"))
        {
            this.showingText = false;
            DirectionalSigns.directionalSignsMenu.ShowMenu(network);
        }
    }
    void IRaycastable.OnRayEnter() { }

    void IRaycastable.OnRayExit()
    {
        if (this.showingText)
        {
            ComponentManager<CanvasHelper>.Value.displayTextManager.HideDisplayTexts();
            this.showingText = false;
        }
    }
}

class DirectionalSignRay : MonoBehaviour, IRaycastable
{
    protected bool showingText = false;
    public DirectionalSign_Network network;

    void IRaycastable.OnIsRayed()
    {
        CanvasHelper canvas = ComponentManager<CanvasHelper>.Value;
        canvas.displayTextManager.ShowText(LocalizationManager.GetTranslation("DirectionalSign/Change", true, 0, true, false, null, null), MyInput.Keybinds["Interact"].MainKey);
        this.showingText = true;
        if (MyInput.GetButtonDown("Interact"))
        {
            this.showingText = false;
            DirectionalSigns.directionalSignsMenu.ShowMenu(network);
        }
    }
    void IRaycastable.OnRayEnter() { }

    void IRaycastable.OnRayExit()
    {
        if (this.showingText)
        {
            ComponentManager<CanvasHelper>.Value.displayTextManager.HideDisplayTexts();
            this.showingText = false;
        }
    }
}