﻿using I2.Loc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TMPro;
using UnityEngine;
using UnityEngine.UI;
using static Mono.Math.BigInteger;
using static Mono.Security.PKCS7;

public class DirectionalSignsMenu : MonoBehaviour
{
    private CanvasGroup canvas_group;

    GameObject sign_1_settings;
    GameObject sign_2_settings;
    GameObject sign_3_settings;
    GameObject sign_4_settings;
    GameObject sign_5_settings;

    Slider slider_1;
    Slider slider_2;
    Slider slider_3;
    Slider slider_4;
    Slider slider_5;

    TMP_InputField inputfield_1;
    TMP_InputField inputfield_2;
    TMP_InputField inputfield_3;
    TMP_InputField inputfield_4;
    TMP_InputField inputfield_5;

    DirectionalSign_Network network;

    TMP_Dropdown dropdown;

    private bool shown = false;

    void Start()
    {
        this.canvas_group = this.GetComponent<CanvasGroup>();

        sign_1_settings = GameObject.Find("sign_1_settings");
        sign_2_settings = GameObject.Find("sign_2_settings");
        sign_3_settings = GameObject.Find("sign_3_settings");
        sign_4_settings = GameObject.Find("sign_4_settings");
        sign_5_settings = GameObject.Find("sign_5_settings");

        slider_1 = GameObject.Find("slider_1").GetComponent<Slider>();
        slider_2 = GameObject.Find("slider_2").GetComponent<Slider>();
        slider_3 = GameObject.Find("slider_3").GetComponent<Slider>();
        slider_4 = GameObject.Find("slider_4").GetComponent<Slider>();
        slider_5 = GameObject.Find("slider_5").GetComponent<Slider>();

        inputfield_1 = GameObject.Find("inputfield_1").GetComponent<TMP_InputField>();
        inputfield_2 = GameObject.Find("inputfield_2").GetComponent<TMP_InputField>();
        inputfield_3 = GameObject.Find("inputfield_3").GetComponent<TMP_InputField>();
        inputfield_4 = GameObject.Find("inputfield_4").GetComponent<TMP_InputField>();
        inputfield_5 = GameObject.Find("inputfield_5").GetComponent<TMP_InputField>();

        inputfield_1.onValueChanged.AddListener(delegate
        {
            InputValueChanged(inputfield_1, 1);
        });

        inputfield_2.onValueChanged.AddListener(delegate
        {
            InputValueChanged(inputfield_2, 2);
        });

        inputfield_3.onValueChanged.AddListener(delegate
        {
            InputValueChanged(inputfield_3, 3);
        });

        inputfield_4.onValueChanged.AddListener(delegate
        {
            InputValueChanged(inputfield_4, 4);
        });

        inputfield_5.onValueChanged.AddListener(delegate
        {
            InputValueChanged(inputfield_5, 5);
        });

        slider_1.onValueChanged.AddListener(delegate
        {
            SliderValueChanged(slider_1, 1);
        });

        slider_2.onValueChanged.AddListener(delegate
        {
            SliderValueChanged(slider_2, 2);
        });

        slider_3.onValueChanged.AddListener(delegate
        {
            SliderValueChanged(slider_3, 3);
        });

        slider_4.onValueChanged.AddListener(delegate
        {
            SliderValueChanged(slider_4, 4);
        });

        slider_5.onValueChanged.AddListener(delegate
        {
            SliderValueChanged(slider_5, 5);
        });

        sign_2_settings.SetActive(false);
        sign_3_settings.SetActive(false);
        sign_4_settings.SetActive(false);
        sign_5_settings.SetActive(false);

        dropdown = this.GetComponentInChildren<TMP_Dropdown>();
        dropdown.onValueChanged.AddListener(delegate
        {
            DropdownValueChanged(dropdown);
        });

        this.HideMenu();
    }

    void InputValueChanged(TMP_InputField inputfield, int sign_id)
    {
        GameObject sign = null;
        switch (sign_id)
        {
            case 1:
                sign = network.sign_1;
                network.sign_data.sign_1_text = inputfield.text;
                break;
            case 2:
                sign = network.sign_2;
                network.sign_data.sign_2_text = inputfield.text;
                break;
            case 3:
                sign = network.sign_3;
                network.sign_data.sign_3_text = inputfield.text;
                break;
            case 4:
                sign = network.sign_4;
                network.sign_data.sign_4_text = inputfield.text;
                break;
            case 5:
                sign = network.sign_5;
                network.sign_data.sign_5_text = inputfield.text;
                break;
        }

        TMP_Text[] texts = sign.gameObject.GetComponentsInChildren<TMP_Text>();

        foreach(TMP_Text text in texts)
        {
            text.text = inputfield.text;
        }

        MessageHandler.SendMessage(new DirectionalSign_ChangeData((Messages)MessageHandler.NetworkMessages.DirectionalSign_ChangeData, network.index, network.sign_data));
    }

    void SliderValueChanged(Slider slider, int sign_id)
    {
        GameObject sign = null;
        float rotation = slider.value * 15f;

        switch (sign_id)
        {
            case 1:
                sign = network.sign_1;
                network.sign_data.sign_1_rotation = rotation;
                break;
            case 2:
                sign = network.sign_2;
                network.sign_data.sign_2_rotation = rotation;
                break;
            case 3:
                sign = network.sign_3;
                network.sign_data.sign_3_rotation = rotation;
                break;
            case 4:
                sign = network.sign_4;
                network.sign_data.sign_4_rotation = rotation;
                break;
            case 5:
                sign = network.sign_5;
                network.sign_data.sign_5_rotation = rotation;
                break;
        }

        sign.transform.localRotation = Quaternion.Euler(transform.localEulerAngles.x, rotation, transform.localEulerAngles.z);
        MessageHandler.SendMessage(new DirectionalSign_ChangeData((Messages)MessageHandler.NetworkMessages.DirectionalSign_ChangeData, network.index, network.sign_data));
    }

    void DropdownValueChanged(TMP_Dropdown dropdown)
    {
        switch (dropdown.value)
        {
            case 0:
                sign_1_settings.SetActive(true);
                sign_2_settings.SetActive(false);
                sign_3_settings.SetActive(false);
                sign_4_settings.SetActive(false);
                sign_5_settings.SetActive(false);

                network.sign_1.SetActive(true);
                network.sign_2.SetActive(false);
                network.sign_3.SetActive(false);
                network.sign_4.SetActive(false);
                network.sign_5.SetActive(false);

                network.top.transform.localPosition = new Vector3(0.0f, 1.58731f, 0.0f);
                network.sign_data.sign_1_enabled = true;
                network.sign_data.sign_2_enabled = false;
                network.sign_data.sign_3_enabled = false;
                network.sign_data.sign_4_enabled = false;
                network.sign_data.sign_5_enabled = false;
                break;
            case 1:
                sign_1_settings.SetActive(true);
                sign_2_settings.SetActive(true);
                sign_3_settings.SetActive(false);
                sign_4_settings.SetActive(false);
                sign_5_settings.SetActive(false);

                network.sign_1.SetActive(true);
                network.sign_2.SetActive(true);
                network.sign_3.SetActive(false);
                network.sign_4.SetActive(false);
                network.sign_5.SetActive(false);

                network.top.transform.localPosition = new Vector3(0.0f, 1.78721f, 0.0f);
                network.sign_data.sign_1_enabled = true;
                network.sign_data.sign_2_enabled = true;
                network.sign_data.sign_3_enabled = false;
                network.sign_data.sign_4_enabled = false;
                network.sign_data.sign_5_enabled = false;
                break;
            case 2:
                sign_1_settings.SetActive(true);
                sign_2_settings.SetActive(true);
                sign_3_settings.SetActive(true);
                sign_4_settings.SetActive(false);
                sign_5_settings.SetActive(false);

                network.sign_1.SetActive(true);
                network.sign_2.SetActive(true);
                network.sign_3.SetActive(true);
                network.sign_4.SetActive(false);
                network.sign_5.SetActive(false);

                network.top.transform.localPosition = new Vector3(0.0f, 1.98711f, 0.0f);
                network.sign_data.sign_1_enabled = true;
                network.sign_data.sign_2_enabled = true;
                network.sign_data.sign_3_enabled = true;
                network.sign_data.sign_4_enabled = false;
                network.sign_data.sign_5_enabled = false;
                break;
            case 3:
                sign_1_settings.SetActive(true);
                sign_2_settings.SetActive(true);
                sign_3_settings.SetActive(true);
                sign_4_settings.SetActive(true);
                sign_5_settings.SetActive(false);

                network.sign_1.SetActive(true);
                network.sign_2.SetActive(true);
                network.sign_3.SetActive(true);
                network.sign_4.SetActive(true);
                network.sign_5.SetActive(false);

                network.top.transform.localPosition = new Vector3(0.0f, 2.18701f, 0.0f);
                network.sign_data.sign_1_enabled = true;
                network.sign_data.sign_2_enabled = true;
                network.sign_data.sign_3_enabled = true;
                network.sign_data.sign_4_enabled = true;
                network.sign_data.sign_5_enabled = false;
                break;
            case 4:
                sign_1_settings.SetActive(true);
                sign_2_settings.SetActive(true);
                sign_3_settings.SetActive(true);
                sign_4_settings.SetActive(true);
                sign_5_settings.SetActive(true);

                network.sign_1.SetActive(true);
                network.sign_2.SetActive(true);
                network.sign_3.SetActive(true);
                network.sign_4.SetActive(true);
                network.sign_5.SetActive(true);

                network.top.transform.localPosition = new Vector3(0.0f, 2.38691f, 0.0f);
                network.sign_data.sign_1_enabled = true;
                network.sign_data.sign_2_enabled = true;
                network.sign_data.sign_3_enabled = true;
                network.sign_data.sign_4_enabled = true;
                network.sign_data.sign_5_enabled = true;
                break;
        }

        MessageHandler.SendMessage(new DirectionalSign_ChangeData((Messages)MessageHandler.NetworkMessages.DirectionalSign_ChangeData, network.index, network.sign_data));
    }

    void Update()
    {
        if (this.shown && Input.GetKeyDown("escape"))
        {
            this.HideMenu();
        }
    }
    public void HideMenu()
    {
        this.canvas_group.alpha = 0;
        this.canvas_group.interactable = false;
        this.canvas_group.blocksRaycasts = false;
        this.shown = false;

        RAPI.ToggleCursor(false);
    }

    public void ShowMenu(DirectionalSign_Network network)
    {
        this.network = network;

        GameObject.Find("MenuMainText").GetComponent<Text>().text = LocalizationManager.GetTranslation("CraftingSub/DirectionalSign", true, 0, true, false, null, null);
        GameObject.Find("SignCountText").GetComponent<Text>().text = LocalizationManager.GetTranslation("DirectionalSign/Count", true, 0, true, false, null, null);
        foreach (Text text in this.gameObject.GetComponentsInChildren<Text>())
        {
            if(text.gameObject.name.Contains("label_rot"))
            {
                text.text = LocalizationManager.GetTranslation("DirectionalSign/Rotation", true, 0, true, false, null, null);
            }
            else if(text.gameObject.name.Contains("label_text"))
            {
                text.text = LocalizationManager.GetTranslation("DirectionalSign/Text", true, 0, true, false, null, null);
            }
        }

        foreach (TMP_Text text in this.gameObject.GetComponentsInChildren<TMP_Text>())
        {
            if (text.gameObject.name.Contains("Placeholder"))
            {
                text.text = LocalizationManager.GetTranslation("DirectionalSign/EnterText", true, 0, true, false, null, null);
            }
        }

        if (network.sign_data.sign_1_enabled && !network.sign_data.sign_2_enabled && !network.sign_data.sign_3_enabled && !network.sign_data.sign_4_enabled && !network.sign_data.sign_5_enabled)
        {
            this.dropdown.value = 0;
        }
        else if (network.sign_data.sign_1_enabled && network.sign_data.sign_2_enabled && !network.sign_data.sign_3_enabled && !network.sign_data.sign_4_enabled && !network.sign_data.sign_5_enabled)
        {
            this.dropdown.value = 1;
        }
        else if (network.sign_data.sign_1_enabled && network.sign_data.sign_2_enabled && network.sign_data.sign_3_enabled && !network.sign_data.sign_4_enabled && !network.sign_data.sign_5_enabled)
        {
            this.dropdown.value = 2;
        }
        else if (network.sign_data.sign_1_enabled && network.sign_data.sign_2_enabled && network.sign_data.sign_3_enabled && network.sign_data.sign_4_enabled && !network.sign_data.sign_5_enabled)
        {
            this.dropdown.value = 3;
        }
        else if (network.sign_data.sign_1_enabled && network.sign_data.sign_2_enabled && network.sign_data.sign_3_enabled && network.sign_data.sign_4_enabled && network.sign_data.sign_5_enabled)
        {
            this.dropdown.value = 4;
        }

        slider_1.value = network.sign_data.sign_1_rotation / 15f;
        slider_2.value = network.sign_data.sign_2_rotation / 15f;
        slider_3.value = network.sign_data.sign_3_rotation / 15f;
        slider_4.value = network.sign_data.sign_4_rotation / 15f;
        slider_5.value = network.sign_data.sign_5_rotation / 15f;

        inputfield_1.text = network.sign_data.sign_1_text;
        inputfield_2.text = network.sign_data.sign_2_text;
        inputfield_3.text = network.sign_data.sign_3_text;
        inputfield_4.text = network.sign_data.sign_4_text;
        inputfield_5.text = network.sign_data.sign_5_text;

        this.canvas_group.alpha = 1;
        this.canvas_group.interactable = true;
        this.canvas_group.blocksRaycasts = true;

        this.shown = true;
        RAPI.ToggleCursor(true);
    }
}