﻿using Steamworks;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using TMPro;
using UnityEngine;
using static Mono.Security.PKCS7;

public class MessageHandler : MonoBehaviour
{
    public enum NetworkMessages
    {
        DirectionalSign_ChangeData = 4893,
    }

    public static void SendMessage(Message message)
    {
        if (Raft_Network.IsHost)
        {
            RAPI.GetLocalPlayer().Network.RPC(message, Target.Other, EP2PSend.k_EP2PSendReliable, (NetworkChannel)72);
        }
        else
        {
            RAPI.GetLocalPlayer().SendP2P(message, EP2PSend.k_EP2PSendReliable, (NetworkChannel)72);
        }
    }

#pragma warning disable CS1998
    public async void ReadP2P_Channel_DirectionalSigns()
#pragma warning restore CS1998
    {
        if (RAPI.IsCurrentSceneMainMenu()) { return; }
        uint num;
        while (SteamNetworking.IsP2PPacketAvailable(out num, 72))
        {
            byte[] array = new byte[num];
            uint num2;
            CSteamID csteamID;
            if (SteamNetworking.ReadP2PPacket(array, num, out num2, out csteamID, 72))
            {
                MemoryStream serializationStream = new MemoryStream(array);
                BinaryFormatter bf = new BinaryFormatter();
                bf.Binder = new PreMergeToMergedDeserializationBinder();
                Packet packet = bf.Deserialize(serializationStream) as Packet;
                Packet_Multiple packet_Multiple;
                if (packet.PacketType == PacketType.Single)
                {
                    Packet_Single packet_Single = packet as Packet_Single;
                    packet_Multiple = new Packet_Multiple(packet_Single.SendType);
                    packet_Multiple.messages = new Message[]
                    {
                        packet_Single.message
                    };
                }
                else
                {
                    packet_Multiple = (packet as Packet_Multiple);
                }
                List<Message> list = packet_Multiple.messages.ToList();
                for (int i = 0; i < list.Count; i++)
                {
                    Message message = list[i];
                    if (message != null)
                    {
                        Messages type = message.Type;
                        switch (type)
                        {
                            case (Messages)NetworkMessages.DirectionalSign_ChangeData:
                                {
                                    if (Raft_Network.IsHost)
                                    {
                                        RAPI.GetLocalPlayer().Network.RPC(message, Target.Other, EP2PSend.k_EP2PSendReliable, (NetworkChannel)72);
                                    }

                                    DirectionalSign_ChangeData msg = message as DirectionalSign_ChangeData;
                                    DirectionalSign_Network network = DirectionalSigns.signs[msg.object_index];

                                    network.sign_data = msg.data;

                                    network.sign_1.SetActive(msg.data.sign_1_enabled);
                                    foreach (TMP_Text text in network.sign_1.gameObject.GetComponentsInChildren<TMP_Text>())
                                    {
                                        text.text = msg.data.sign_1_text;
                                    }
                                    network.sign_1.transform.localRotation = Quaternion.Euler(0.0f, msg.data.sign_1_rotation, 0.0f);
                                   
                                    network.sign_2.SetActive(msg.data.sign_2_enabled);
                                    foreach (TMP_Text text in network.sign_2.gameObject.GetComponentsInChildren<TMP_Text>())
                                    {
                                        text.text = msg.data.sign_2_text;
                                    }
                                    network.sign_2.transform.localRotation = Quaternion.Euler(0.0f, msg.data.sign_2_rotation, 0.0f);

                                    network.sign_3.SetActive(msg.data.sign_3_enabled);
                                    foreach (TMP_Text text in network.sign_3.gameObject.GetComponentsInChildren<TMP_Text>())
                                    {
                                        text.text = msg.data.sign_3_text;
                                    }
                                    network.sign_3.transform.localRotation = Quaternion.Euler(0.0f, msg.data.sign_3_rotation, 0.0f);

                                    network.sign_4.SetActive(msg.data.sign_4_enabled);
                                    foreach (TMP_Text text in network.sign_4.gameObject.GetComponentsInChildren<TMP_Text>())
                                    {
                                        text.text = msg.data.sign_4_text;
                                    }
                                    network.sign_4.transform.localRotation = Quaternion.Euler(0.0f, msg.data.sign_4_rotation, 0.0f);

                                    network.sign_5.SetActive(msg.data.sign_5_enabled);
                                    foreach (TMP_Text text in network.sign_5.gameObject.GetComponentsInChildren<TMP_Text>())
                                    {
                                        text.text = msg.data.sign_5_text;
                                    }
                                    network.sign_5.transform.localRotation = Quaternion.Euler(0.0f, msg.data.sign_5_rotation, 0.0f);

                                    if (msg.data.sign_1_enabled && !msg.data.sign_2_enabled && !msg.data.sign_3_enabled && !msg.data.sign_4_enabled && !msg.data.sign_5_enabled)
                                    {
                                        network.top.transform.localPosition = new Vector3(0.0f, 1.58731f, 0.0f);
                                    }
                                    else if (msg.data.sign_1_enabled && msg.data.sign_2_enabled && !msg.data.sign_3_enabled && !msg.data.sign_4_enabled && !msg.data.sign_5_enabled)
                                    {
                                        network.top.transform.localPosition = new Vector3(0.0f, 1.78721f, 0.0f);
                                    }
                                    else if (msg.data.sign_1_enabled && msg.data.sign_2_enabled && msg.data.sign_3_enabled && !msg.data.sign_4_enabled && !msg.data.sign_5_enabled)
                                    {
                                        network.top.transform.localPosition = new Vector3(0.0f, 1.98711f, 0.0f);
                                    }
                                    else if (msg.data.sign_1_enabled && msg.data.sign_2_enabled && msg.data.sign_3_enabled && msg.data.sign_4_enabled && !msg.data.sign_5_enabled)
                                    {
                                        network.top.transform.localPosition = new Vector3(0.0f, 2.18701f, 0.0f);
                                    }
                                    else if (msg.data.sign_1_enabled && msg.data.sign_2_enabled && msg.data.sign_3_enabled && msg.data.sign_4_enabled && msg.data.sign_5_enabled)
                                    {
                                        network.top.transform.localPosition = new Vector3(0.0f, 2.38691f, 0.0f);
                                    }
                                    break;
                                }
                        }
                    }

                }
            }
        }
    }
}
sealed class PreMergeToMergedDeserializationBinder : SerializationBinder
{
    public override Type BindToType(string assemblyName, string typeName)
    {
        Type typeToDeserialize = null;
        String exeAssembly = Assembly.GetExecutingAssembly().FullName;
        typeToDeserialize = Type.GetType(String.Format("{0}, {1}", typeName, exeAssembly));
        return typeToDeserialize;
    }
}
